OpenTTD Source: StoryBookWindow Struct Reference

OpenTTD Source 15.0-beta1

Data Structures | Public Member Functions | Protected Types | Protected Member Functions | Static Protected Member Functions | Protected Attributes | Static Protected Attributes
StoryBookWindow Struct Reference
Inheritance diagram for StoryBookWindow:

## Data Structures
struct | LayoutCacheElement

## Public Member Functions
| StoryBookWindow (WindowDesc &desc, WindowNumber window_number)
void | UpdatePrevNextDisabledState ()
| Updates the disabled state of the prev/next buttons.
void | SetSelectedPage (uint16_t page_index)
| Sets the selected page.
void | SetStringParameters (WidgetID widget) const override
| Initialize string parameters for a widget.
void | OnPaint () override
| The window must be repainted.
void | DrawWidget (const Rect &r, WidgetID widget) const override
| Draw the contents of a nested widget.
void | UpdateWidgetSize (WidgetID widget, Dimension &size, const Dimension &padding, Dimension &fill, Dimension &resize) override
| Update size and resize step of a widget in the window.
void | OnResize () override
| Called after the window got resized.
void | OnClick (Point pt, WidgetID widget, int click_count) override
| A click with the left mouse button has been made on the window.
void | OnDropdownSelect (WidgetID widget, int index) override
| A dropdown option associated to this window has been selected.
void | OnInvalidateData (int data=0, bool gui_scope=true) override
| Some data on this window has become invalid.
void | OnTimeout () override
| Called when this window's timeout has been reached.
void | OnPlaceObject (Point pt, TileIndex tile) override
| The user clicked some place on the map when a tile highlight mode has been set.
bool | OnVehicleSelect (const Vehicle *v) override
void | OnPlaceObjectAbort () override
| The user cancelled a tile highlight mode that has been set.
Public Member Functions inherited from Window
| Window (WindowDesc &desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class.
void * | operator new[] (size_t size)=delete
| Helper allocation function to disallow something.
template<class NWID >
const NWID * | GetWidget (WidgetID widnum) const
| Get the nested widget with number widnum from the nested widget tree.
template<class NWID >
NWID * | GetWidget (WidgetID widnum)
| Get the nested widget with number widnum from the nested widget tree.
const Scrollbar * | GetScrollbar (WidgetID widnum) const
| Return the Scrollbar to a widget index.
Scrollbar * | GetScrollbar (WidgetID widnum)
| Return the Scrollbar to a widget index.
const QueryString * | GetQueryString (WidgetID widnum) const
| Return the querystring associated to a editbox.
QueryString * | GetQueryString (WidgetID widnum)
| Return the querystring associated to a editbox.
void | UpdateQueryStringSize ()
| Update size of all QueryStrings of this window.
virtual const struct Textbuf * | GetFocusedTextbuf () const
| Get the current input text buffer.
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus.
virtual Rect | GetTextBoundingRect (const char *from, const char *to) const
| Get the bounding rectangle for a text range if an edit box has the focus.
virtual ptrdiff_t | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box.
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use.
void | CreateNestedTree ()
| Perform the first part of the initialization of a nested widget tree.
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree.
template<typename T , std::enable_if_t< std::is_base_of< StrongTypedefBase, T >::value, int > = 0>
void | FinishInitNested (T number)
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (WidgetID widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget.
bool | IsWidgetHighlighted (WidgetID widget_index) const
| Gets the highlighted status of a widget.
void | SetWidgetDisabledState (WidgetID widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget.
void | DisableWidget (WidgetID widget_index)
| Sets a widget to disabled.
void | EnableWidget (WidgetID widget_index)
| Sets a widget to Enabled.
bool | IsWidgetDisabled (WidgetID widget_index) const
| Gets the enabled/disabled status of a widget.
bool | IsWidgetFocused (WidgetID widget_index) const
| Check if given widget is focused within this window.
bool | IsWidgetGloballyFocused (WidgetID widget_index) const
| Check if given widget has user input focus.
void | SetWidgetLoweredState (WidgetID widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget.
void | ToggleWidgetLoweredState (WidgetID widget_index)
| Invert the lowered/raised status of a widget.
void | LowerWidget (WidgetID widget_index)
| Marks a widget as lowered.
void | RaiseWidget (WidgetID widget_index)
| Marks a widget as raised.
void | RaiseWidgetWhenLowered (WidgetID widget_index)
| Marks a widget as raised and dirty (redraw), when it is marked as lowered.
bool | IsWidgetLowered (WidgetID widget_index) const
| Gets the lowered state of a widget.
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus.
bool | SetFocusedWidget (WidgetID widget_index)
| Set focus within this window to the given widget.
EventState | HandleEditBoxKey (WidgetID wid, char32_t key, uint16_t keycode)
| Process keypress for editbox widget.
virtual void | InsertTextString (WidgetID wid, const char *str, bool marked, const char *caret, const char *insert_location, const char *replacement_end)
| Insert a text string at the cursor position into the edit box widget.
void | HandleButtonClick (WidgetID widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks.
int | GetRowFromWidget (int clickpos, WidgetID widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in.
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window.
template<typename... Args>
void | SetWidgetsDisabledState (bool disab_stat, Args... widgets)
| Sets the enabled/disabled status of a list of widgets.
template<typename... Args>
void | SetWidgetsLoweredState (bool lowered_stat, Args... widgets)
| Sets the lowered/raised status of a list of widgets.
template<typename... Args>
void | RaiseWidgetsWhenLowered (Args... widgets)
| Raises the widgets and sets widgets dirty that are lowered.
void | SetWidgetDirty (WidgetID widget_index) const
| Invalidate a widget, i.e.
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (WidgetID widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol.
Window * | FindChildWindow (WindowClass wc=WC_INVALID) const
| Find the Window whose parent pointer points to this window.
void | CloseChildWindows (WindowClass wc=WC_INVALID) const
| Close all children a window might have in a head-recursive manner.
virtual void | Close (int data=0)
| Hide the window and all its child windows, and mark them for a later deletion.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0, bool reposition=false)
| Re-initialize a window, and optionally change its size.
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded.
void | ScheduleResize ()
| Mark this window as resized and in need of OnResize() event.
void | ProcessScheduledResize ()
| Process scheduled OnResize() event.
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing)
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | OnInit ()
| Notification that the nested widget tree gets initialized.
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16_t sm_width, int16_t sm_height, int window_number)
| Compute the initial position of the window.
virtual void | OnFocus ()
| The window has gained focus.
virtual void | OnFocusLost (bool closing)
| The window has lost focus.
virtual EventState | OnKeyPress (char32_t key, uint16_t keycode)
| A key has been pressed.
virtual EventState | OnHotkey (int hotkey)
| A hotkey has been pressed.
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed.
virtual bool | OnRightClick (Point pt, WidgetID widget)
| A click with the right mouse button has been made on the window.
virtual void | OnHover (Point pt, WidgetID widget)
| The mouse is hovering over a widget in the window, perform an action for it.
virtual bool | OnTooltip (Point pt, WidgetID widget, TooltipCloseCondition close_cond)
| Event to display a custom tooltip.
virtual void | OnMouseDrag (Point pt, WidgetID widget)
| An 'object' is being dragged at the provided position, highlight the target if possible.
virtual void | OnDragDrop (Point pt, WidgetID widget)
| A dragged 'object' has been released.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
virtual void | OnMouseOver (Point pt, WidgetID widget)
| The mouse is currently moving over the window or has just moved outside of the window.
virtual void | OnMouseWheel (int wheel)
| The mouse wheel has been turned.
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnGameTick ()
| Called once per (game) tick.
virtual void | OnRealtimeTick (uint delta_ms)
| Called periodically.
virtual void | OnDropdownClose (Point pt, WidgetID widget, int index, bool instant_close)
| A dropdown window associated to this window has been closed.
virtual void | OnEditboxChanged (WidgetID widget)
| The text in an editbox has been edited.
virtual void | OnQueryTextFinished (std::optional< std::string > str)
| The query window opened from this window has closed.
virtual bool | OnVehicleSelect (const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual bool | OnVehicleSelect (VehicleList::const_iterator begin, VehicleList::const_iterator end)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set.
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set.
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable?
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window.
template<>
const NWidgetBase * | GetWidget (WidgetID widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances.
void | operator delete (void *ptr)
| Memory release for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.

## Protected Types
enum class | ElementFloat { None , Left , Right }
typedef std::vector< LayoutCacheElement > | LayoutCache

## Protected Member Functions
void | BuildStoryPageList ()
| (Re)Build story page list.
void | BuildStoryPageElementList ()
| (Re)Build story page element list.
bool | IsPageAvailable (const StoryPage *page) const
StoryPage * | GetSelPage () const
| Get instance of selected page.
int | GetSelPageNum () const
| Get the page number of selected page.
bool | IsFirstPageSelected ()
| Check if the selected page is also the first available page.
bool | IsLastPageSelected ()
| Check if the selected page is also the last available page.
void | RefreshSelectedPage ()
| Updates the content of selected page.
void | SelectPrevPage ()
| Selects the previous available page before the currently selected page.
void | SelectNextPage ()
| Selects the next available page after the currently selected page.
DropDownList | BuildDropDownList () const
| Builds the page selector drop down list.
uint | GetAvailablePageContentWidth () const
| Get the width available for displaying content on the page panel.
uint | GetHeadHeight (int max_width) const
| Counts how many pixels of height that are used by Date and Title (excluding marginal after Title, as each body element has an empty row before the element).
SpriteID | GetPageElementSprite (const StoryPageElement &pe) const
| Decides which sprite to display for a given page element.
uint | GetPageElementHeight (const StoryPageElement &pe, int max_width) const
| Get the height in pixels used by a page element.
ElementFloat | GetPageElementFloat (const StoryPageElement &pe) const
| Get the float style of a page element.
int | GetPageElementFloatWidth (const StoryPageElement &pe) const
| Get the width a page element would use if it was floating left or right.
void | InvalidateStoryPageElementLayout ()
| Invalidate the current page layout.
void | EnsureStoryPageElementLayout () const
| Create the page layout if it is missing.
int32_t | GetContentHeight ()
| Get the total height of the content displayed in this window.
void | DrawActionElement (int &y_offset, int width, int line_height, SpriteID action_sprite, StringID string_id=STR_JUST_RAW_STRING) const
| Draws a page element that is composed of a sprite to the left and a single line of text after that.
void | OnPageElementClick (const StoryPageElement &pe)
| Internal event handler for when a page element is clicked.
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window.
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window.
virtual void | FindWindowPlacementAndResize (int def_width, int def_height)
| Resize window towards the default size.
virtual | ~Window ()
| Remove window and all its child windows from the window stack.

## Static Protected Member Functions
static bool | PageOrderSorter (const StoryPage *const &a, const StoryPage *const &b)
| Sort story pages by order value.
static bool | PageElementOrderSorter (const StoryPageElement *const &a, const StoryPageElement *const &b)
| Sort story page elements by order value.

## Protected Attributes
Scrollbar * | vscroll
| Scrollbar of the page text.
LayoutCache | layout_cache
| Cached element layout.
GUIStoryPageList | story_pages
| Sorted list of pages.
GUIStoryPageElementList | story_page_elements
| Sorted list of page elements that belong to the current page.
StoryPageID | selected_page_id
| Pool index of selected page.
std::string | selected_generic_title
| If the selected page doesn't have a custom title, this buffer is used to store a generic page title.
StoryPageElementID | active_button_id
| Which button element the player is currently using.
Protected Attributes inherited from Window
std::vector< int > | scheduled_invalidation_data
| Data of scheduled OnInvalidateData() calls.
bool | scheduled_resize
| Set if window has been resized.

## Static Protected Attributes
static const std::initializer_list< GUIStoryPageList::SortFunction *const > | page_sorter_funcs
static const std::initializer_list< GUIStoryPageElementList::SortFunction *const > | page_element_sorter_funcs

## Additional Inherited Members
Public Types inherited from Window
using | IteratorToFront = WindowIterator< false >
| Iterate in Z order towards front.
using | IteratorToBack = WindowIterator< true >
| Iterate in Z order towards back.
using | Iterate = AllWindows< false >
| Iterate all windows in whatever order is easiest.
using | IterateFromBack = AllWindows< false >
| Iterate all windows in Z order from back to front.
using | IterateFromFront = AllWindows< true >
| Iterate all windows in Z order from front to back.
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state.
static void | DeleteClosedWindows ()
| Delete all closed windows.
Data Fields inherited from Window
WindowDesc & | window_desc
| Window description.
WindowFlags | flags
| Window flags.
WindowClass | window_class
| Window class.
WindowNumber | window_number
| Window number within the window class.
int | scale
| Scale of this window – used to determine how to resize.
uint8_t | timeout_timer
| Timer value of the WF_TIMEOUT for flags.
uint8_t | white_border_timer
| Timer value of the WF_WHITE_BORDER for flags.
int | left
| x position of left edge of the window
int | top
| y position of top edge of the window
int | width
| width of the window (number of pixels to the right in x direction)
int | height
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize
| Resize information.
Owner | owner
| The owner of the content shown in this window. Company colour is acquired from this variable.
ViewportData * | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus
| Currently focused nested widget, or `nullptr` if no nested widget has focus.
std::map< WidgetID, QueryString * > | querystrings
| QueryString associated to WWT_EDITBOX widgets.
std::unique_ptr< NWidgetBase > | nested_root
| Root of the nested tree.
WidgetLookup | widget_lookup
| Indexed access to the nested widget tree. Do not access directly, use Window::GetWidget() instead.
NWidgetStacked * | shade_select
| Selection widget (NWID_SELECTION) to use for shading the window. If `nullptr`, window cannot shade.
Dimension | unshaded_size
| Last known unshaded size (only valid while shaded).
WidgetID | mouse_capture_widget
| ID of current mouse capture widget (e.g. dragged scrollbar). -1 if no widget has mouse capture.
Window * | parent
| Parent window.
WindowList::iterator | z_position

## Detailed Description

Definition at line 41 of file story_gui.cpp.

## Member Typedef Documentation

## ◆ LayoutCache

typedef std::vector<LayoutCacheElement> StoryBookWindow::LayoutCache
| protected

Definition at line 47 of file story_gui.cpp.

## Member Enumeration Documentation

## ◆ ElementFloat

enum class StoryBookWindow::ElementFloat
| strongprotected

Definition at line 49 of file story_gui.cpp.

## Constructor & Destructor Documentation

## ◆ StoryBookWindow()

StoryBookWindow::StoryBookWindow | ( | WindowDesc & | desc,
|  | WindowNumber | window_number
| ) |  |
| inline

Definition at line 593 of file story_gui.cpp.

## Member Function Documentation

## ◆ BuildDropDownList()

DropDownList StoryBookWindow::BuildDropDownList | ( |  | ) | const
| inlineprotected

Builds the page selector drop down list.

Definition at line 247 of file story_gui.cpp.

References Window::GetWidget(), selected_page_id, SetDParam(), and story_pages.

Referenced by OnClick().

## ◆ BuildStoryPageElementList()

void StoryBookWindow::BuildStoryPageElementList | ( |  | ) |
| inlineprotected

(Re)Build story page element list.

Definition at line 93 of file story_gui.cpp.

References GetSelPage(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, InvalidateStoryPageElementLayout(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_story_page_element_pool >::Iterate(), GUIList< T, P, F >::NeedRebuild(), GUIList< T, P, F >::RebuildDone(), and GUIList< T, P, F >::Sort().

Referenced by RefreshSelectedPage().

## ◆ BuildStoryPageList()

void StoryBookWindow::BuildStoryPageList | ( |  | ) |
| inlineprotected

(Re)Build story page list.

Definition at line 69 of file story_gui.cpp.

References Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_story_page_pool >::Iterate(), GUIList< T, P, F >::NeedRebuild(), GUIList< T, P, F >::RebuildDone(), and GUIList< T, P, F >::Sort().

Referenced by OnInvalidateData().

## ◆ DrawActionElement()

void StoryBookWindow::DrawActionElement | ( | int & | y_offset,
|  | int | width,
|  | int | line_height,
|  | SpriteID | action_sprite,
|  | StringID | string_id = `STR_JUST_RAW_STRING`
| ) |  | const
| inlineprotected

Draws a page element that is composed of a sprite to the left and a single line of text after that.

These page elements are generally clickable and are thus called action elements.

Parameters

  y_offset | Current y_offset which will get updated when this method has completed its drawing.
  width | Width of the region available for drawing.
  line_height | Height of one line of text.
  action_sprite | The sprite to draw.
  string_id | The string id to draw.

Returns
  the number of lines.

Definition at line 517 of file story_gui.cpp.

References DrawSprite(), DrawString(), WidgetDimensions::frametext, GetSpriteSize(), Window::GetWidget(), WidgetDimensions::scaled, and Window::width.

Referenced by DrawWidget().

## ◆ DrawWidget()

void StoryBookWindow::DrawWidget | ( | const Rect & | r,
|  | WidgetID | widget
| ) |  | const
| inlineoverridevirtual

Draw the contents of a nested widget.

Parameters

  r | Rectangle occupied by the widget.
  widget | Number of the widget to draw.

Note
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 678 of file story_gui.cpp.

References WidgetDimensions::bevel, StoryPage::date, DrawActionElement(), DrawFrameRect(), DrawString(), DrawStringMultiLine(), EnsureStoryPageElementLayout(), FillDrawPixelInfo(), FR_LOWERED, WidgetDimensions::frametext, FS_NORMAL, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_goal_pool >::Get(), GetCharacterHeight(), GetPageElementSprite(), Scrollbar::GetPosition(), GetSelPage(), Window::GetWidget(), TimerGameConst< struct Calendar >::INVALID_DATE, layout_cache, SA_CENTER, SA_HOR_CENTER, SA_LEFT, SA_TOP, WidgetDimensions::scaled, selected_generic_title, SetDParam(), SetDParamStr(), Rect::Shrink(), SPET_BUTTON_PUSH, SPET_BUTTON_TILE, SPET_BUTTON_VEHICLE, SPET_GOAL, SPET_LOCATION, SPET_TEXT, Goal::text, StoryPage::title, and WID_SB_PAGE_PANEL.

## ◆ EnsureStoryPageElementLayout()

void StoryBookWindow::EnsureStoryPageElementLayout | ( |  | ) | const
| inlineprotected

Create the page layout if it is missing.

Definition at line 397 of file story_gui.cpp.

References FS_NORMAL, GetAvailablePageContentWidth(), GetCharacterHeight(), GetHeadHeight(), GetPageElementFloat(), GetPageElementFloatWidth(), GetPageElementHeight(), GetSelPage(), Window::GetWidget(), Window::height, SPET_BUTTON_PUSH, SPET_BUTTON_TILE, SPET_BUTTON_VEHICLE, and story_page_elements.

Referenced by DrawWidget(), GetContentHeight(), and OnClick().

## ◆ GetAvailablePageContentWidth()

uint StoryBookWindow::GetAvailablePageContentWidth | ( |  | ) | const
| inlineprotected

Get the width available for displaying content on the page panel.

Definition at line 269 of file story_gui.cpp.

References WidgetDimensions::frametext, Window::GetWidget(), RectPadding::Horizontal(), WidgetDimensions::scaled, and WID_SB_PAGE_PANEL.

Referenced by EnsureStoryPageElementLayout().

## ◆ GetContentHeight()

int32_t StoryBookWindow::GetContentHeight | ( |  | ) |
| inlineprotected

Get the total height of the content displayed in this window.

Returns
  the height in pixels

Definition at line 496 of file story_gui.cpp.

References EnsureStoryPageElementLayout(), and Window::GetWidget().

Referenced by OnPaint(), OnResize(), and RefreshSelectedPage().

## ◆ GetHeadHeight()

uint StoryBookWindow::GetHeadHeight | ( | int | max_width | ) | const
| inlineprotected

Counts how many pixels of height that are used by Date and Title (excluding marginal after Title, as each body element has an empty row before the element).

Parameters

  max_width | Available width to display content.

Returns
  the height in pixels.

Definition at line 281 of file story_gui.cpp.

References FS_NORMAL, GetCharacterHeight(), GetSelPage(), GetStringHeight(), Window::GetWidget(), Window::height, selected_generic_title, SetDParamStr(), and StoryPage::title.

Referenced by EnsureStoryPageElementLayout().

## ◆ GetPageElementFloat()

ElementFloat StoryBookWindow::GetPageElementFloat | ( | const StoryPageElement & | pe | ) | const
| inlineprotected

Get the float style of a page element.

Parameters

  pe | The story page element.

Returns
  The float style.

Definition at line 353 of file story_gui.cpp.

References Window::flags, StoryPageElement::referenced_id, SPET_BUTTON_PUSH, SPET_BUTTON_TILE, SPET_BUTTON_VEHICLE, and StoryPageElement::type.

Referenced by EnsureStoryPageElementLayout().

## ◆ GetPageElementFloatWidth()

int StoryBookWindow::GetPageElementFloatWidth | ( | const StoryPageElement & | pe | ) | const
| inlineprotected

Get the width a page element would use if it was floating left or right.

Parameters

  pe | The story page element.

Returns
  The calculated width of the element.

Definition at line 375 of file story_gui.cpp.

References WidgetDimensions::framerect, WidgetDimensions::frametext, FS_NORMAL, GetStringBoundingBox(), WidgetDimensions::scaled, SPET_BUTTON_PUSH, SPET_BUTTON_TILE, SPET_BUTTON_VEHICLE, StoryPageElement::text, StoryPageElement::type, and RectPadding::Vertical().

Referenced by EnsureStoryPageElementLayout().

## ◆ GetPageElementHeight()

uint StoryBookWindow::GetPageElementHeight | ( | const StoryPageElement & | pe,
|  | int | max_width
| ) |  | const
| inlineprotected

Get the height in pixels used by a page element.

Parameters

  pe | The story page element.
  max_width | Available width to display content.

Returns
  the height in pixels.

Definition at line 322 of file story_gui.cpp.

References WidgetDimensions::framerect, WidgetDimensions::frametext, FS_NORMAL, GetPageElementSprite(), GetSpriteSize(), GetStringBoundingBox(), GetStringHeight(), Window::GetWidget(), WidgetDimensions::scaled, SetDParamStr(), SPET_BUTTON_PUSH, SPET_BUTTON_TILE, SPET_BUTTON_VEHICLE, SPET_GOAL, SPET_LOCATION, SPET_TEXT, StoryPageElement::text, StoryPageElement::type, and RectPadding::Vertical().

Referenced by EnsureStoryPageElementLayout().

## ◆ GetPageElementSprite()

SpriteID StoryBookWindow::GetPageElementSprite | ( | const StoryPageElement & | pe | ) | const
| inlineprotected

Decides which sprite to display for a given page element.

Parameters

  pe | The page element.

Returns
  The SpriteID of the sprite to display.

Precondition
  pe.type must be SPET_GOAL or SPET_LOCATION.

Definition at line 301 of file story_gui.cpp.

References Goal::completed, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_goal_pool >::Get(), StoryPageElement::referenced_id, SPET_GOAL, SPET_LOCATION, and StoryPageElement::type.

Referenced by DrawWidget(), and GetPageElementHeight().

## ◆ GetSelPage()

StoryPage * StoryBookWindow::GetSelPage | ( |  | ) | const
| inlineprotected

Get instance of selected page.

Returns
  Instance of selected page or nullptr if no page is selected.

Definition at line 134 of file story_gui.cpp.

References Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::Get(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::IsValidID(), and selected_page_id.

Referenced by BuildStoryPageElementList(), DrawWidget(), EnsureStoryPageElementLayout(), GetHeadHeight(), RefreshSelectedPage(), and SetStringParameters().

## ◆ GetSelPageNum()

int StoryBookWindow::GetSelPageNum | ( |  | ) | const
| inlineprotected

Get the page number of selected page.

Returns
  Number of available pages before to the selected one, or -1 if no page is selected.

Definition at line 144 of file story_gui.cpp.

References Window::GetWidget(), and story_pages.

Referenced by RefreshSelectedPage().

## ◆ InvalidateStoryPageElementLayout()

void StoryBookWindow::InvalidateStoryPageElementLayout | ( |  | ) |
| inlineprotected

Invalidate the current page layout.

Definition at line 391 of file story_gui.cpp.

Referenced by BuildStoryPageElementList(), and OnResize().

## ◆ IsFirstPageSelected()

bool StoryBookWindow::IsFirstPageSelected | ( |  | ) |
| inlineprotected

Check if the selected page is also the first available page.

Definition at line 159 of file story_gui.cpp.

References Window::GetWidget(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::IsValidID(), and selected_page_id.

## ◆ IsLastPageSelected()

bool StoryBookWindow::IsLastPageSelected | ( |  | ) |
| inlineprotected

Check if the selected page is also the last available page.

Definition at line 170 of file story_gui.cpp.

References Window::GetWidget(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::IsValidID(), and selected_page_id.

## ◆ IsPageAvailable()

bool StoryBookWindow::IsPageAvailable | ( | const StoryPage * | page | ) | const
| inlineprotected

Definition at line 125 of file story_gui.cpp.

## ◆ OnClick()

void StoryBookWindow::OnClick | ( | Point | pt,
|  | WidgetID | widget,
|  | int | click_count
| ) |  |
| inlineoverridevirtual

A click with the left mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.
  click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 802 of file story_gui.cpp.

References BuildDropDownList(), EnsureStoryPageElementLayout(), WidgetDimensions::frametext, Scrollbar::GetScrolledRowFromWidget(), Window::GetWidget(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, layout_cache, OnPageElementClick(), WidgetDimensions::scaled, SelectNextPage(), SelectPrevPage(), ShowDropDownList(), WID_SB_NEXT_PAGE, WID_SB_PAGE_PANEL, WID_SB_PREV_PAGE, and WID_SB_SEL_PAGE.

## ◆ OnDropdownSelect()

void StoryBookWindow::OnDropdownSelect | ( | WidgetID | widget,
|  | int | index
| ) |  |
| inlineoverridevirtual

A dropdown option associated to this window has been selected.

Parameters

  widget | the widget (button) that the dropdown is associated with.
  index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 843 of file story_gui.cpp.

References SetSelectedPage(), and WID_SB_SEL_PAGE.

## ◆ OnInvalidateData()

void StoryBookWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true`
| ) |  |
| inlineoverridevirtual

Some data on this window has become invalid.

Parameters

  data | Information about the changed data. -1 Rebuild page list and refresh current page; >= 0 Id of the page that needs to be refreshed. If it is not the current page, nothing happens.
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 858 of file story_gui.cpp.

References BuildStoryPageList(), GUIList< T, P, F >::ForceRebuild(), Window::GetWidget(), INVALID_STORY_PAGE, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::IsValidID(), RefreshSelectedPage(), SetSelectedPage(), Window::SetWidgetDirty(), Window::SetWidgetDisabledState(), UpdatePrevNextDisabledState(), and WID_SB_SEL_PAGE.

## ◆ OnPageElementClick()

void StoryBookWindow::OnPageElementClick | ( | const StoryPageElement & | pe | ) |
| inlineprotected

Internal event handler for when a page element is clicked.

Parameters

  pe | The clicked page element.

Definition at line 535 of file story_gui.cpp.

References _ctrl_pressed, HT_RECT, HT_VEHICLE, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, INVALID_STORY_PAGE_ELEMENT, StoryPageElement::referenced_id, ResetObjectToPlace(), ScrollMainWindowToTile(), SetObjectToPlaceWnd(), Window::SetTimeout(), Window::SetWidgetDirty(), ShowExtraViewportWindow(), ShowGoalsList(), SPET_BUTTON_PUSH, SPET_BUTTON_TILE, SPET_BUTTON_VEHICLE, SPET_GOAL, SPET_LOCATION, SPET_TEXT, StoryPageElement::type, WID_SB_PAGE_PANEL, and Window::window_number.

Referenced by OnClick().

## ◆ OnPaint()

void StoryBookWindow::OnPaint | ( |  | ) |
| inlineoverridevirtual

The window must be repainted.

Note
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 663 of file story_gui.cpp.

References Window::DrawWidgets(), GetContentHeight(), Scrollbar::GetCount(), Window::GetWidget(), Scrollbar::SetCount(), Window::SetWidgetDirty(), WID_SB_PAGE_PANEL, and WID_SB_SCROLLBAR.

## ◆ OnPlaceObject()

void StoryBookWindow::OnPlaceObject | ( | Point | pt,
|  | TileIndex | tile
| ) |  |
| inlineoverridevirtual

The user clicked some place on the map when a tile highlight mode has been set.

Parameters

  pt | the exact point on the map that has been clicked.
  tile | the tile on the map that has been clicked.

Reimplemented from Window.

Definition at line 899 of file story_gui.cpp.

References Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_story_page_element_pool >::GetIfValid(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, INVALID_STORY_PAGE_ELEMENT, ResetObjectToPlace(), Window::SetWidgetDirty(), SPET_BUTTON_TILE, StoryPageElement::type, and WID_SB_PAGE_PANEL.

## ◆ OnPlaceObjectAbort()

void StoryBookWindow::OnPlaceObjectAbort | ( |  | ) |
| inlineoverridevirtual

The user cancelled a tile highlight mode that has been set.

Reimplemented from Window.

Definition at line 933 of file story_gui.cpp.

References INVALID_STORY_PAGE_ELEMENT, Window::SetWidgetDirty(), and WID_SB_PAGE_PANEL.

## ◆ OnResize()

void StoryBookWindow::OnResize | ( |  | ) |
| inlineoverridevirtual

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 795 of file story_gui.cpp.

References GetContentHeight(), InvalidateStoryPageElementLayout(), WidgetDimensions::scaled, Scrollbar::SetCapacityFromWidget(), Scrollbar::SetCount(), and WID_SB_PAGE_PANEL.

## ◆ OnTimeout()

void StoryBookWindow::OnTimeout | ( |  | ) |
| inlineoverridevirtual

Called when this window's timeout has been reached.

Reimplemented from Window.

Definition at line 893 of file story_gui.cpp.

References INVALID_STORY_PAGE_ELEMENT, Window::SetWidgetDirty(), and WID_SB_PAGE_PANEL.

## ◆ OnVehicleSelect()

bool StoryBookWindow::OnVehicleSelect | ( | const Vehicle * | v | ) |
| inlineoverride

Definition at line 913 of file story_gui.cpp.

## ◆ PageElementOrderSorter()

static bool StoryBookWindow::PageElementOrderSorter | ( | const StoryPageElement *const & | a,
|  | const StoryPageElement *const & | b
| ) |  |
| inlinestaticprotected

Sort story page elements by order value.

Definition at line 115 of file story_gui.cpp.

References StoryPageElement::sort_value.

## ◆ PageOrderSorter()

static bool StoryBookWindow::PageOrderSorter | ( | const StoryPage *const & | a,
|  | const StoryPage *const & | b
| ) |  |
| inlinestaticprotected

Sort story pages by order value.

Definition at line 87 of file story_gui.cpp.

References StoryPage::sort_value.

## ◆ RefreshSelectedPage()

void StoryBookWindow::RefreshSelectedPage | ( |  | ) |
| inlineprotected

Updates the content of selected page.

Definition at line 183 of file story_gui.cpp.

References BuildStoryPageElementList(), GUIList< T, P, F >::ForceRebuild(), GetContentHeight(), GetSelPage(), GetSelPageNum(), GetString(), Window::GetWidget(), INVALID_STORY_PAGE_ELEMENT, ResetObjectToPlace(), selected_generic_title, Scrollbar::SetCount(), SetDParam(), Window::SetWidgetDirty(), StoryPage::title, WID_SB_PAGE_PANEL, WID_SB_SCROLLBAR, and WID_SB_SEL_PAGE.

Referenced by OnInvalidateData(), and SetSelectedPage().

## ◆ SelectNextPage()

void StoryBookWindow::SelectNextPage | ( |  | ) |
| inlineprotected

Selects the next available page after the currently selected page.

Definition at line 226 of file story_gui.cpp.

References Window::GetWidget(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::IsValidID(), and SetSelectedPage().

Referenced by OnClick().

## ◆ SelectPrevPage()

void StoryBookWindow::SelectPrevPage | ( |  | ) |
| inlineprotected

Selects the previous available page before the currently selected page.

Definition at line 206 of file story_gui.cpp.

References Window::GetWidget(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::IsValidID(), SetSelectedPage(), and story_pages.

Referenced by OnClick().

## ◆ SetSelectedPage()

void StoryBookWindow::SetSelectedPage | ( | uint16_t | page_index | ) |
| inline

Sets the selected page.

Parameters

  page_index | pool index of the page to select.

Definition at line 633 of file story_gui.cpp.

References Window::GetWidget(), INVALID_STORY_PAGE_ELEMENT, RefreshSelectedPage(), ResetObjectToPlace(), and UpdatePrevNextDisabledState().

Referenced by OnDropdownSelect(), OnInvalidateData(), SelectNextPage(), SelectPrevPage(), and ShowStoryBook().

## ◆ SetStringParameters()

void StoryBookWindow::SetStringParameters | ( | WidgetID | widget | ) | const
| inlineoverridevirtual

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters

  widget | Widget number.

Reimplemented from Window.

Definition at line 644 of file story_gui.cpp.

References GetSelPage(), Window::GetWidget(), INVALID_COMPANY, selected_generic_title, SetDParam(), SetDParamStr(), StoryPage::title, WID_SB_CAPTION, and WID_SB_SEL_PAGE.

## ◆ UpdatePrevNextDisabledState()

void StoryBookWindow::UpdatePrevNextDisabledState | ( |  | ) |
| inline

Updates the disabled state of the prev/next buttons.

Definition at line 621 of file story_gui.cpp.

References Window::GetWidget(), Window::SetWidgetDirty(), Window::SetWidgetDisabledState(), WID_SB_NEXT_PAGE, and WID_SB_PREV_PAGE.

Referenced by OnInvalidateData(), and SetSelectedPage().

## ◆ UpdateWidgetSize()

void StoryBookWindow::UpdateWidgetSize | ( | WidgetID | widget,
|  | Dimension & | size,
|  | const Dimension & | padding,
|  | Dimension & | fill,
|  | Dimension & | resize
| ) |  |
| inlineoverridevirtual

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters

  | widget | Widget number.
  [in,out] | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  [in,out] | fill | Fill step of the widget.
  [in,out] | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 752 of file story_gui.cpp.

References WidgetDimensions::frametext, FS_NORMAL, GetCharacterHeight(), GetStringBoundingBox(), Window::GetWidget(), maxdim(), WidgetDimensions::scaled, SetDParamStr(), StoryPage::title, RectPadding::Vertical(), WID_SB_PAGE_PANEL, and WID_SB_SEL_PAGE.

## Field Documentation

## ◆ active_button_id

StoryPageElementID StoryBookWindow::active_button_id
| protected

Which button element the player is currently using.

Definition at line 63 of file story_gui.cpp.

## ◆ layout_cache

LayoutCache StoryBookWindow::layout_cache
| mutableprotected

Cached element layout.

Definition at line 56 of file story_gui.cpp.

Referenced by DrawWidget(), and OnClick().

## ◆ page_element_sorter_funcs

const std::initializer_list< GUIStoryPageElementList::SortFunction *const > StoryBookWindow::page_element_sorter_funcs
| staticprotected

Initial value:
= {
&PageElementOrderSorter,
}
StoryBookWindow::PageElementOrderSorter
static bool PageElementOrderSorter(const StoryPageElement *const &a, const StoryPageElement *const &b)
Sort story page elements by order value.
Definition story_gui.cpp:115

Definition at line 944 of file story_gui.cpp.

## ◆ page_sorter_funcs

const std::initializer_list< GUIStoryPageList::SortFunction *const > StoryBookWindow::page_sorter_funcs
| staticprotected

Initial value:
= {
&PageOrderSorter,
}
StoryBookWindow::PageOrderSorter
static bool PageOrderSorter(const StoryPage *const &a, const StoryPage *const &b)
Sort story pages by order value.
Definition story_gui.cpp:87

Definition at line 940 of file story_gui.cpp.

## ◆ selected_generic_title

std::string StoryBookWindow::selected_generic_title
| protected

If the selected page doesn't have a custom title, this buffer is used to store a generic page title.

Definition at line 61 of file story_gui.cpp.

Referenced by DrawWidget(), GetHeadHeight(), RefreshSelectedPage(), and SetStringParameters().

## ◆ selected_page_id

StoryPageID StoryBookWindow::selected_page_id
| protected

Pool index of selected page.

Definition at line 60 of file story_gui.cpp.

Referenced by BuildDropDownList(), GetSelPage(), IsFirstPageSelected(), and IsLastPageSelected().

## ◆ story_page_elements

GUIStoryPageElementList StoryBookWindow::story_page_elements
| protected

Sorted list of page elements that belong to the current page.

Definition at line 59 of file story_gui.cpp.

Referenced by EnsureStoryPageElementLayout().

## ◆ story_pages

GUIStoryPageList StoryBookWindow::story_pages
| protected

Sorted list of pages.

Definition at line 58 of file story_gui.cpp.

Referenced by BuildDropDownList(), GetSelPageNum(), and SelectPrevPage().

## ◆ vscroll

Scrollbar* StoryBookWindow::vscroll
| protected

Scrollbar of the page text.

Definition at line 55 of file story_gui.cpp.

The documentation for this struct was generated from the following file:

- src/story_gui.cpp